"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _is_js = _interopRequireDefault(require("is_js"));

var _browserLocale = _interopRequireDefault(require("browser-locale"));

var _cardsy = _interopRequireDefault(require("cardsy"));

var _max = require("libphonenumber-js/max");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Validator =
/*#__PURE__*/
function () {
  function Validator() {
    _classCallCheck(this, Validator);
  }

  _createClass(Validator, null, [{
    key: "validateValue",
    value: function validateValue(valueString, validation, minValue, maxValue, suppliedCountryCode, minLength, creditCardNumber) {
      if (minLength !== undefined && valueString.length < minLength) {
        return false;
      }

      if (typeof validation === 'function') {
        return validation(valueString);
      }

      if (Array.isArray(validation)) {
        return validation.includes(valueString);
      }

      if (_typeof(validation) === 'object') {
        return !!valueString.match(validation);
      }

      return Validator.validateValueWithPredefinedValidation(valueString, validation, minValue, maxValue, suppliedCountryCode, creditCardNumber);
    } // eslint-disable-next-line consistent-return

  }, {
    key: "validateValueWithPredefinedValidation",
    value: function validateValueWithPredefinedValidation(valueString, validation, minValue, maxValue, suppliedCountryCode, creditCardNumber) {
      var valueAsNumber = 0;

      if (validation === 'number') {
        valueAsNumber = parseFloat(valueString);
      } else if (validation === 'integer') {
        if (valueString.includes('.')) {
          valueAsNumber = NaN;
        } else {
          valueAsNumber = parseInt(valueString, 10);
        }
      }

      var countryCode = suppliedCountryCode || (0, _browserLocale.default)().split('-')[1];

      switch (validation) {
        case 'url':
          return _is_js.default.url(valueString);

        case 'emailAddress':
          return _is_js.default.email(valueString);

        case 'creditCardNumber':
          return _cardsy.default.validate.number(valueString.replace(/\s/g, ''));

        case 'creditCardExpiration':
          return _cardsy.default.validate.expiryString(valueString);

        case 'creditCardVerificationCode':
          return creditCardNumber ? _cardsy.default.validate.cvc(valueString, _cardsy.default.getType(creditCardNumber.replace(/\s/g, ''))) : valueString.match(/^\d{3,4}$/) !== null;

        case 'number':
        case 'integer':
          return !Number.isNaN(valueAsNumber) && (minValue === undefined || valueAsNumber >= minValue) && (maxValue === undefined || valueAsNumber <= maxValue);

        case 'alphaNumeric':
          return _is_js.default.alphaNumeric(valueString);

        case 'usZipCode':
          return _is_js.default.usZipCode(valueString);

        case 'caPostCode':
          return _is_js.default.caPostalCode(valueString);

        case 'ukPostCode':
          return _is_js.default.ukPostCode(valueString);

        case 'phoneNumber':
          return (0, _max.parsePhoneNumberFromString)(valueString, countryCode) !== undefined;

        case 'usSSN':
          return _is_js.default.socialSecurityNumber(valueString);

        case 'ipAddress':
          return _is_js.default.ip(valueString);

        case 'ipv4Address':
          return _is_js.default.ipv4(valueString);

        case 'ipv6Address':
          return _is_js.default.ipv6(valueString);

        case 'hexColor':
          return _is_js.default.hexColor(valueString);
        // no default
      }
    }
  }]);

  return Validator;
}();

exports.default = Validator;
//# sourceMappingURL=Validator.js.map